var gulp = require("gulp");
var uglify = require("gulp-uglify");
var rimraf = require("gulp-rimraf");
var rename = require("gulp-rename");
var browserify = require('browserify');
var source = require('vinyl-source-stream');
var mocha = require('gulp-mocha');
var gulpUtil = require('gulp-util');

gulp.task("clean",function(){
    gulp.src("./dest/**/*.*")
    .pipe(rimraf())
})

gulp.task("assemble",["clean"], function () {
  // set up the browserify instance on a task basis
  return  browserify({
		entries: './src/app.js',
		debug: false,
        standalone:"iso8601Date"
	})
	.bundle()
    .pipe(source('iso8601-date.js'))
    .pipe(gulp.dest('./dest'));
});

gulp.task("build",["assemble"],function(){
    gulp.src("./dest/iso8601-date.js")
        .pipe(uglify().on('error', gulpUtil.log))
        .pipe(rename("iso8601-date.min.js"))
        .pipe(gulp.dest("./dest/"))
});

gulp.task('test',['build'],function(){
    gulp.src('./test/*.js')
    .pipe(mocha({reporter:"spec"}))
});

gulp.task("default",["build","test"]);